SystemOrganization addCategory: #'EjerciciosPoo-OnlineSale'!

Error subclass: #CanNotAddANegativeOrZeroQuantityException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

Object subclass: #Product
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

TestCase subclass: #Cart
	instanceVariableNames: 'aQuantity productsContained'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:47'!
add: aNewProduct quantity: aQuantityOfProduct 
 (aQuantityOfProduct<=0) ifTrue:[CanNotAddANegativeOrZeroQuantityException signal.] 
	ifFalse: [
	productsContained add: aNewProduct. 
	aQuantity := aQuantity+ aQuantityOfProduct.
	].
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:51'!
contains: aProduct 
	^ productsContained includes: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:47'!
initialize
	aQuantity:=0.
	productsContained:= Set new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:27'!
quantityOfProducts
	^ aQuantity.! !

TestCase subclass: #OnlineSaleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/7/2012 20:57'!
aCart
	^Cart new.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/7/2012 20:59'!
aProduct
	^ Product new.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/7/2012 21:08'!
aSecondProduct
	^ Product new.! !

!OnlineSaleTest methodsFor: 'accessing' stamp: 'GabrielBursztyn 6/12/2012 16:42'!
shouldNotAddANegativeOrZeroQuantityException
	^CanNotAddANegativeOrZeroQuantityException.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/7/2012 20:29'!
test01NewCartCannotContainsProducts

	self assert: (self aCart) quantityOfProducts = 0.
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/7/2012 21:01'!
test02GivenACartWhenAddAProductThenTheCartContainThis

	| aCart aProduct|
	
	aCart := self aCart.
	aProduct := self aProduct.
	aCart add: aProduct quantity: 3.
	
	self assert: (aCart contains: aProduct).
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/7/2012 21:08'!
test03GivenACartWhenAddAProductThenTheCartNotContainAnotherProduct

	| aCart aProduct aSecondProduct|
	
	aCart := self aCart.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCart add: aProduct quantity: 3.
	
	self deny: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:29'!
test04GivenACartWhenAddAProductThenTheCartContainsTheQuantityAddedOfThatProduct

	| aCart aProduct |
	
	aCart := self aCart.
	aProduct := self aProduct.
	aCart add: aProduct quantity: 3.
	self assert: (aCart quantityOfProducts = 3).
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:29'!
test05GivenACartWhenAddAProductThatAlreadyExistsThenTheCartContainsTheSumOfTheQuantities

	| aCart aProduct |
	
	aCart := self aCart.
	aProduct := self aProduct.
	aCart add: aProduct quantity: 3.
	aCart add: aProduct quantity: 4.
	self assert: (aCart quantityOfProducts = 7).
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:42'!
test06GivenACartWhenAddAProductThenTheQuantityShouldNotBeNegative

	| aCart aProduct |
	
	aCart := self aCart.
	aProduct := self aProduct.
	self should: [ aCart add: aProduct quantity: -1] raise: self shouldNotAddANegativeOrZeroQuantityException.
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:42'!
test07GivenACartWhenAddAProductThenTheQuantityShouldNotBeZero

	| aCart aProduct |
	
	aCart := self aCart.
	aProduct := self aProduct.
	self should: [ aCart add: aProduct quantity: 0] raise: self shouldNotAddANegativeOrZeroQuantityException.
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:45'!
test08GivenACartWhenAddAProductAndAnotherProductThenTheCartContainsBothProducts

	| aCart aProduct aSecondProduct|
	
	aCart := self aCart.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCart add: aProduct quantity: 3.
	aCart add: aSecondProduct quantity: 1.

	self assert: (aCart contains: aProduct).	
	self assert: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:52'!
test09GivenACartWhenAddAProductAndAnotherProductThenTheCartCanReturnAListOfTheProductsWithItsQuantities

	| aCart aProduct aSecondProduct|
	
	aCart := self aCart.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCart add: aProduct quantity: 3.
	aCart add: aSecondProduct quantity: 1.

	self assert: (aCart contains: aProduct).	
	self assert: (aCart contains: aSecondProduct).
	! !
